
//***************************************************************************************
//*
//* α׷  : EgoCube IE Analysis 0.0.2
//*
//*         : ͳ ͽ÷η   м α׷
//*
//*       : ۿ
//*
//* ۼ  : 2004.02.20
//*
//*   : 2004.03.24
//*
//* EgoCube IE Analysis 0.0.2   ƮԴϴ.  Ǵ   
//* 𿡼 Ӱ Ͻ  ֽϴ.  ߰    ڵ带 
//* ô ,     Ͽ   ּż    
//*   ֵ ֽø ϰڽϴ. , ̷  Code    
//*  Ͽ  Ȩ 뿡 ߰ϵ ϰڽϴ. ó  ϴ.
//*     
//*     Homepage URL : http://www.egocube.pe.kr/
//*
//*     E-Mail       : songgun@egocube.pe.kr
//*
//*  α׷ Ϻ ڵ,  URLComboBox ƮѰ õ ڵ THE CODE PROJECT Ʈ
//* κ Ͽ ۼ Դϴ. THE CODE PROJECT Ʈ  ش   URL  
//*  ϴ.  ش Ʈ ۱ǰ õ  ش Ʈ  ħ
//*    Ģ մϴ.
//*
//*     Ʈ URL   : http://www.codeproject.com/
//*
//*     ù URL : http://www.codeproject.com/cs/combobox/urlcombo.asp
//*
//***************************************************************************************

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Microsoft.Win32;
using AxSHDocVw;
using SHDocVw;
using mshtml;

namespace IEAnalysis
{
	/// <summary>
	/// frmMain ŬԴϴ.
	/// </summary>
    public class frmMain : System.Windows.Forms.Form, DWebBrowserEvents
    {
        private enum MessageType {Cookie, Event, Information, Message, Header, Window};
        private enum ToolBarButtonState {HTML, EventList};
        
        private UCOMIConnectionPoint ICP; 

        private int iCookie = -1;
        private int iLastTagSrcIndex = -1;

        private string strCookie = "";

        private string strBorderColor = "";
        private string strBorderStyle = "";
        private string strBorderWidth = "";

        private System.IO.FileStream objFileStream;
        private System.IO.StreamWriter objStreamWriter;

        private AxSHDocVw.AxWebBrowser wbMain;
        
        private System.Windows.Forms.StatusBar sbMain;
        private System.Windows.Forms.StatusBarPanel sbPanelMain;
        
        private System.Windows.Forms.TreeView tvHTMLDOM;
        
        private System.Windows.Forms.ListView lvInfo;
        
        private System.Windows.Forms.TextBox txtHTML;
        
        private System.Windows.Forms.Timer tmrSelector;

        private System.Windows.Forms.Panel pnlLeft;
        private System.Windows.Forms.Panel pnlBottom;
        
        private CP.Windows.Forms.URLComboBox cmbAddress;
        private System.Windows.Forms.ComboBox cmbFrame;

        private System.Windows.Forms.Splitter spterVirtical;
        private System.Windows.Forms.Splitter spterHorizontal;

        private System.Windows.Forms.ImageList ilTooBar;
        private System.Windows.Forms.ImageList ilTreeView;

        private System.Windows.Forms.ToolBar tbMain;
        private System.Windows.Forms.ToolBarButton tbBack;
        private System.Windows.Forms.ToolBarButton tbForward;
        private System.Windows.Forms.ToolBarButton tbStop;
        private System.Windows.Forms.ToolBarButton tbRefresh;
        private System.Windows.Forms.ToolBarButton tbHome;
        private System.Windows.Forms.ToolBarButton tbSeparator01;
        private System.Windows.Forms.ToolBarButton tbButton01;
        private System.Windows.Forms.ToolBarButton tbButton02;
        private System.Windows.Forms.ToolBarButton tbSeparator02;
        private System.Windows.Forms.ToolBarButton tbExpandAll;
        private System.Windows.Forms.ToolBarButton tbSeparator03;
        private System.Windows.Forms.ToolBarButton tbExplorer;
        private System.Windows.Forms.ToolBarButton tbSeparator04;
        private System.Windows.Forms.ToolBarButton tbEgoCube;
        
        private System.Windows.Forms.MainMenu menuMain;

        private System.Windows.Forms.MenuItem menuFile;
        private System.Windows.Forms.MenuItem menuSave;
        private System.Windows.Forms.MenuItem menuSaveAs;
        private System.Windows.Forms.MenuItem menuSP11;
        private System.Windows.Forms.MenuItem menuPageSetup;
        private System.Windows.Forms.MenuItem menuPrint;
        private System.Windows.Forms.MenuItem menuPrintPreview;
        private System.Windows.Forms.MenuItem menuSP12;
        private System.Windows.Forms.MenuItem menuOpenNavigationEventLog;
        private System.Windows.Forms.MenuItem menuSP13;
        private System.Windows.Forms.MenuItem menuProperty;
        private System.Windows.Forms.MenuItem menuExit;

        private System.Windows.Forms.MenuItem menuEdit;
        private System.Windows.Forms.MenuItem menuCut;
        private System.Windows.Forms.MenuItem menuCopy;
        private System.Windows.Forms.MenuItem menuPaste;
        private System.Windows.Forms.MenuItem menuSP21;
        private System.Windows.Forms.MenuItem menuSelectAll;

        private System.Windows.Forms.MenuItem menuView;
        private System.Windows.Forms.MenuItem menuMove;
        private System.Windows.Forms.MenuItem menuBack;
        private System.Windows.Forms.MenuItem menuForward;
        private System.Windows.Forms.MenuItem menuSP311;
        private System.Windows.Forms.MenuItem menuHome;
        private System.Windows.Forms.MenuItem menuStop;
        private System.Windows.Forms.MenuItem menuRefresh;
        private System.Windows.Forms.MenuItem menuSP31;
        private System.Windows.Forms.MenuItem menuHTMLTag;
        private System.Windows.Forms.MenuItem menuNavigationEventLog;
        private System.Windows.Forms.MenuItem menuSP32;
        private System.Windows.Forms.MenuItem menuTextSize;
        private System.Windows.Forms.MenuItem menuTextSizeG;
        private System.Windows.Forms.MenuItem menuTextSizeL;
        private System.Windows.Forms.MenuItem menuTextSizeM;
        private System.Windows.Forms.MenuItem menuTextSizeS;
        private System.Windows.Forms.MenuItem menuTextSizeA;
        private System.Windows.Forms.MenuItem menuSP33;
        private System.Windows.Forms.MenuItem menuDOMTreeExpand;
        private System.Windows.Forms.MenuItem menuSP34;
        private System.Windows.Forms.MenuItem menuIEShow;

        private System.Windows.Forms.MenuItem menuHelp;
        private System.Windows.Forms.MenuItem menuHomepage;
        private System.Windows.Forms.MenuItem menuDownload;
        private System.Windows.Forms.MenuItem menuSP41;
        private System.Windows.Forms.MenuItem menuAbout;
        
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// EgoCube IE Analysis α׷  Դϴ.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new frmMain());
        }

        //*******************************************************************************
        //* 
        //*     : Ŭ 
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.18
        //* 
        //*     : frmMain Ŭ ⺻ Դϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// ⺻ Դϴ.
        /// </summary>
        public frmMain()
        {
            InitializeComponent();
            
            //***************************************************************************
            //* DWebBrowserEvents ̽ ̺Ʈ ϱ  ޴ ۾
            //***************************************************************************

            UCOMIConnectionPointContainer ICPC = (UCOMIConnectionPointContainer) wbMain.GetOcx();
            Guid objGUID = typeof(DWebBrowserEvents).GUID;
            ICPC.FindConnectionPoint(ref objGUID, out ICP);
            ICP.Advise(this, out iCookie);

            //***************************************************************************
            //* α   StreamWriter ü 
            //***************************************************************************

            this.objFileStream = new System.IO.FileStream(DateTime.Now.ToString("yyyyMMdd") + ".txt", FileMode.OpenOrCreate | FileMode.Append, FileAccess.Write, FileShare.ReadWrite);
            this.objStreamWriter = new System.IO.StreamWriter(objFileStream, System.Text.Encoding.GetEncoding("euc-kr"));
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.18
        //* 
        //*     :    ҽ մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        ///    ҽ մϴ.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                //***********************************************************************
                //* DWebBrowserEvents ̽ ̺Ʈ ϱ  ۾ 
                //***********************************************************************

                if (-1 != iCookie) ICP.Unadvise(iCookie);
                iCookie = -1;

                //***********************************************************************
                // α   StreamWriter ü 
                //***********************************************************************

                this.objStreamWriter.Close();
                this.objFileStream.Close();

                //***********************************************************************
                // Ÿ ҽ 
                //***********************************************************************

                if (components != null) 
                {
                    components.Dispose();
                }
            }

            base.Dispose(disposing);
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.24
        //* 
        //*     : Ʈѵ Ÿ ʱȭ ۾ óմϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// frmMain  ε  ȣǴ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void frmMain_Load(object sender, System.EventArgs e)
        {
            //** wbMain  Ʈ ʱ ̵ ġ 
            this.wbMain.GoHome();

            //** lvInfo Ʈ Ʈ  ׸ 
            this.lvInfo.View = View.Details;
            this.lvInfo.Columns.Add("ð",  90, HorizontalAlignment.Left);
            this.lvInfo.Columns.Add("", 105, HorizontalAlignment.Left);
            this.lvInfo.Columns.Add("", 400, HorizontalAlignment.Left);
            this.lvInfo.Columns.Add("URL",  500, HorizontalAlignment.Left);

            //** tbMain  Ʈ Ϻ ư ʱ Ӽ 
            this.tbMain.Buttons[0].Enabled = false;
            this.tbMain.Buttons[1].Enabled = false;

            //** mnuMain ޴ Ʈ Ӽ 
            this.menuHTMLTag.Checked = false;
            this.menuNavigationEventLog.Checked = true;
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.15
        //* 
        //*     : ΰħ ư   ȣǴ Refresh2() ޼ҵ忡 ڷ 
        //*           Ǵ RefreshConstants ڴ  Ͻʽÿ.
        //*           typedef enum RefreshConstants {
        //*               REFRESH_NORMAL = 0,      Refresh that does not include sending the HTTP "pragma:nocache" header to the server.
        //*               REFRESH_IFEXPIRED = 1,   Refresh that occurs if the page has expired.
        //*               REFRESH_CONTINUE = 2,    For internal use only; do not use.
        //*               REFRESH_COMPLETELY = 3   Refresh that includes sending a "pragma:nocache" header to the server (HTTP URLs only).
        //*           } RefreshConstants;
        //* 
        //*******************************************************************************

        /// <summary>
        /// tbMain  Ʈ ư Ŭ  ȣǴ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void tbMain_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
        {
            string strTag = e.Button.Tag.ToString();

            switch (strTag)
            {
                case "WB_BACK":
                    
                    this.wbMain.GoBack();
                    break;

                case "WB_FORWARD":
                    
                    this.wbMain.GoForward();
                    break;

                case "WB_STOP":
                    
                    this.wbMain.Stop();
                    break;

                case "WB_REFRESH":

                    object objRefreshConstants = 3;
                    this.wbMain.Refresh2(ref objRefreshConstants);
                    break;

                case "WB_HOME":
                    
                    this.wbMain.GoHome();
                    break;

                case "SHOW_HTML":           //** lvInfo Ʈ ƮѰ txtHTML ؽƮڽ Ʈ   
                    
                    this.SetToolBarButtonState(ToolBarButtonState.HTML);
                    break;

                case "SHOW_EVENTLIST":      //** lvInfo Ʈ ƮѰ txtHTML ؽƮڽ Ʈ   

                    this.SetToolBarButtonState(ToolBarButtonState.EventList);
                    break;

                case "EXPAND_TREE_ALL":     //** tvHTMLDOM Ʈ Ʈ   Ȯ

                    this.Cursor = Cursors.WaitCursor;
                    this.tvHTMLDOM.ExpandAll();
                    this.tvHTMLDOM.Nodes[0].EnsureVisible();
                    this.Cursor = Cursors.Default;
                    break;

                case "EXPLORER":            //** wbMain  Ʈ  URL  ͳ ͽ÷η Ͽ 

                    this.OpenInternetExplorer();
                    break;

                case "EGOCUBE":             //**  Ȩ EgoCube Ȩ ͳ ͽ÷η 

                    this.OpenEgoCube("HOME");
                    break;
            }
    
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.22
        //* 
        //*     : Էµ ڰ Enter   Է¹ URL  ̵մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// cmbAddress URL ޺ڽ Ʈѿ Ű Է Ͼ ߻ϴ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void cmbAddress_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            if ((int) e.KeyValue == 13)
            {
                //***********************************************************************
                //* Enter Ű  
                //***********************************************************************

                object oURL = (object) this.cmbAddress.Text;
                object oEmpty = Type.Missing;
                this.wbMain.Navigate2(ref oURL, ref oEmpty, ref oEmpty, ref oEmpty, ref oEmpty);
            }
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.25
        //* 
        //*   : 2004.03.17
        //* 
        //*     : õ tvHTMLDOM Ʈ Ʈ  ĪǴ HTML ± 
        //*           մϴ.  õ 尡 FRAME ± Ǵ IFRAME ±׿ 
        //*              ش URL  ̵մϴ.
        //*
        //*           õ HTML ±׸ tmrSelector Ÿ̸ Ʈ Tick ̺Ʈ 鷯
        //*           ̿Ͽ ׵θ ¦¦Ÿ ǵ óմϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// tvHTMLDOM Ʈ Ʈ 带 Ŭϸ ߻ϴ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void tvHTMLDOM_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            object oIndex     = Int32.Parse(e.Node.Tag.ToString());
            object oIndexLast = null;
            object oEmpty     = Type.Missing;

            string strTagName = "";


            mshtml.IHTMLDocument2 objDocument2 = (IHTMLDocument2) this.wbMain.Document;
            mshtml.IHTMLElement objElement = objDocument2.all.item(oIndex, oEmpty) as mshtml.IHTMLElement;

            if (objElement != null)
            {
                if (objElement.tagName == "FRAME" || objElement.tagName == "IFRAME")
                {
                    //*******************************************************************
                    //* FRAME ±׳ IFRAME ±׿ Ǵ   ش URL  ̵
                    //*******************************************************************

                    object oURL   = null;
                    string strURL = GetFramedURL(objElement);

                    if (strURL == "")
                        oURL = (object) "about:blank";
                    else
                        oURL = (object) strURL;

                    this.wbMain.Navigate2(ref oURL, ref oEmpty, ref oEmpty,  ref oEmpty,  ref oEmpty);
                }
                else
                {
                    //*******************************************************************
                    //*  ߴ ±  ϱ  ó
                    //*******************************************************************

                    this.tmrSelector.Stop();
                    strTagName = objElement.tagName;

                    //** iLastTagSrcIndex   -1  ƴϸ  õ HTML ±װ 
                    if (iLastTagSrcIndex > -1)
                    {
                        oIndexLast = (object) iLastTagSrcIndex;
                        mshtml.IHTMLElement objSelectedLast = objDocument2.all.item(oIndexLast, oEmpty) as mshtml.IHTMLElement;

                        if (objSelectedLast.tagName == "HTML" || objSelectedLast.tagName == "HEAD" || objSelectedLast.tagName == "TITLE" || objSelectedLast.tagName == "BODY" || objSelectedLast.tagName == "TBODY" || objSelectedLast.tagName == "TR" || objSelectedLast.tagName == "BR")
                        {
                            //** ó ۾ 
                        }
                        else
                        {
                            objSelectedLast.style.borderColor = strBorderColor;
                            objSelectedLast.style.borderStyle = strBorderStyle;
                            objSelectedLast.style.borderWidth = strBorderWidth;
                        }
                    }


                    //*******************************************************************
                    //*  innerHTML Ƽ  ϰ innerHTML Ƽ  
                    //*  outerHTML Ƽ  
                    //*******************************************************************

                    string strInnerHTML = "";

                    try { strInnerHTML = objElement.innerHTML.Trim(); } catch { strInnerHTML = ""; }
                    strInnerHTML = strInnerHTML.Replace("\n", System.Environment.NewLine).Replace("\r\r\n", System.Environment.NewLine);

                    if (strInnerHTML != "")
                    {
                        this.txtHTML.Text = strInnerHTML.Replace("\n", System.Environment.NewLine).Replace("\r\r\n", System.Environment.NewLine);
                    }
                    else
                    {
                        try { this.txtHTML.Text = objElement.outerHTML.Trim(); } catch { }
                    }
                    

                    //*******************************************************************
                    //*  ±׸ ϱ  ó
                    //*******************************************************************

                    if (strTagName == "HTML" || strTagName == "HEAD" || strTagName == "TITLE" || strTagName == "BODY" || strTagName == "TBODY" || strTagName == "TR" || strTagName == "BR")
                    {
                        //** ó ۾ 
                    }
                    else
                    {
                        try { strBorderColor = objElement.style.borderColor; } 
                        
                        catch { strBorderColor = ""; }
                        try { strBorderStyle = objElement.style.borderStyle; } 
                        catch { strBorderStyle = ""; }
                        try { strBorderWidth = objElement.style.borderWidth; } catch { strBorderWidth = ""; }

                        objElement.style.borderColor = "#AAAAFF";
                        objElement.style.borderStyle = "solid";
                        objElement.style.borderWidth = "2px";
                    }

                    //** õ     tmrSelector Ÿ̸ Ʈ Tick ̺Ʈ 鷯 ȣ
                    iLastTagSrcIndex = Int32.Parse(e.Node.Tag.ToString());
                    this.tmrSelector.Start();
                    
                    //** tbMain  Ʈ ư  ó ƿƼ ޼ҵ ȣ
                    SetToolBarButtonState(ToolBarButtonState.HTML);
                }
            }
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.16
        //* 
        //*   : 2004.03.17
        //* 
        //*     : ڰ  HTML ± CSS Style  ݺ 缳Ͽ ±
        //*            ׵θ ¦¦Ÿ ǵ óմϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// tmrSelector Ÿ̸ Ʈ Tick ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void tmrSelector_Tick(object sender, System.EventArgs e)
        {
            if (iLastTagSrcIndex == -1)
            {
                return;
            }
            else
            {
                object oIndexLast = (object) iLastTagSrcIndex;
                object oEmpty     = Type.Missing;

                string strTagName = "";

                mshtml.IHTMLDocument2 objDocument2byMain = (IHTMLDocument2) this.wbMain.Document;
                mshtml.IHTMLElement objSelectedLastbyMain = objDocument2byMain.all.item(oIndexLast, oEmpty) as mshtml.IHTMLElement;

                strTagName = objSelectedLastbyMain.tagName;

                if (strTagName == "HTML" || strTagName == "HEAD" || strTagName == "TITLE" || strTagName == "BODY" || strTagName == "TBODY" || strTagName == "TR" || strTagName == "BR")
                {
                    this.tmrSelector.Stop();
                    return;
                }
                else
                {
                    try 
                    {
                        if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#55DD99")
                            objSelectedLastbyMain.style.borderColor = "#33CCBB";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#33CCBB")
                            objSelectedLastbyMain.style.borderColor = "#55AADD";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#55AADD")
                            objSelectedLastbyMain.style.borderColor = "#7777FF";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#7777FF")
                            objSelectedLastbyMain.style.borderColor = "#9955DD";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#9955DD")
                            objSelectedLastbyMain.style.borderColor = "#BB33BB";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#BB33BB")
                            objSelectedLastbyMain.style.borderColor = "#DD5599";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#DD5599")
                            objSelectedLastbyMain.style.borderColor = "#FF7777";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#FF7777")
                            objSelectedLastbyMain.style.borderColor = "#DD9955";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#DD9955")
                            objSelectedLastbyMain.style.borderColor = "#BBBB33";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#BBBB33")
                            objSelectedLastbyMain.style.borderColor = "#99DD55";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#99DD55")
                            objSelectedLastbyMain.style.borderColor = "#77FF77";
                        else if (objSelectedLastbyMain.style.borderColor.ToUpper() == "#77FF77")
                            objSelectedLastbyMain.style.borderColor = "#55DD99";
                        else
                            objSelectedLastbyMain.style.borderColor = "#55DD99";
                    }
                    catch
                    {
                        //** ó ۾ 
                    }
                }
            }
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.02
        //* 
        //*   : 2004.03.02
        //* 
        //*     : cmbFrame ޺ڽ Ʈ Ʈ õ ׸ URL  ̵մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// cmbFrame ޺ڽ Ʈ Ʈ  ϸ ߻ϴ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void cmbFrame_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (this.cmbFrame.SelectedIndex > 0)
            {
                string strURL = this.cmbFrame.Items[this.cmbFrame.SelectedIndex].ToString();
                object oURL = (object) strURL.Replace("<FRAME>", "").Replace("<IFRAME>", "").Trim();
                object oEmpty = Type.Missing;
                this.wbMain.Navigate2(ref oURL, ref oEmpty, ref oEmpty,  ref oEmpty,  ref oEmpty);
            }
        }

        #region Windows Form Designer Generated Code

        /// <summary>
        /// ̳  ʿ ޼Դϴ.
        ///  ޼  ڵ   ʽÿ.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
            this.menuMain = new System.Windows.Forms.MainMenu();
            this.menuFile = new System.Windows.Forms.MenuItem();
            this.menuSave = new System.Windows.Forms.MenuItem();
            this.menuSaveAs = new System.Windows.Forms.MenuItem();
            this.menuSP11 = new System.Windows.Forms.MenuItem();
            this.menuPageSetup = new System.Windows.Forms.MenuItem();
            this.menuPrint = new System.Windows.Forms.MenuItem();
            this.menuPrintPreview = new System.Windows.Forms.MenuItem();
            this.menuSP12 = new System.Windows.Forms.MenuItem();
            this.menuOpenNavigationEventLog = new System.Windows.Forms.MenuItem();
            this.menuSP13 = new System.Windows.Forms.MenuItem();
            this.menuProperty = new System.Windows.Forms.MenuItem();
            this.menuExit = new System.Windows.Forms.MenuItem();
            this.menuEdit = new System.Windows.Forms.MenuItem();
            this.menuCut = new System.Windows.Forms.MenuItem();
            this.menuCopy = new System.Windows.Forms.MenuItem();
            this.menuPaste = new System.Windows.Forms.MenuItem();
            this.menuSP21 = new System.Windows.Forms.MenuItem();
            this.menuSelectAll = new System.Windows.Forms.MenuItem();
            this.menuView = new System.Windows.Forms.MenuItem();
            this.menuHTMLTag = new System.Windows.Forms.MenuItem();
            this.menuNavigationEventLog = new System.Windows.Forms.MenuItem();
            this.menuSP32 = new System.Windows.Forms.MenuItem();
            this.menuDOMTreeExpand = new System.Windows.Forms.MenuItem();
            this.menuSP34 = new System.Windows.Forms.MenuItem();
            this.menuIEShow = new System.Windows.Forms.MenuItem();
            this.menuHelp = new System.Windows.Forms.MenuItem();
            this.menuHomepage = new System.Windows.Forms.MenuItem();
            this.menuDownload = new System.Windows.Forms.MenuItem();
            this.menuSP41 = new System.Windows.Forms.MenuItem();
            this.menuAbout = new System.Windows.Forms.MenuItem();
            this.tbMain = new System.Windows.Forms.ToolBar();
            this.tbBack = new System.Windows.Forms.ToolBarButton();
            this.tbForward = new System.Windows.Forms.ToolBarButton();
            this.tbStop = new System.Windows.Forms.ToolBarButton();
            this.tbRefresh = new System.Windows.Forms.ToolBarButton();
            this.tbHome = new System.Windows.Forms.ToolBarButton();
            this.tbSeparator01 = new System.Windows.Forms.ToolBarButton();
            this.tbButton01 = new System.Windows.Forms.ToolBarButton();
            this.tbButton02 = new System.Windows.Forms.ToolBarButton();
            this.tbSeparator02 = new System.Windows.Forms.ToolBarButton();
            this.tbExpandAll = new System.Windows.Forms.ToolBarButton();
            this.tbSeparator03 = new System.Windows.Forms.ToolBarButton();
            this.tbExplorer = new System.Windows.Forms.ToolBarButton();
            this.tbSeparator04 = new System.Windows.Forms.ToolBarButton();
            this.tbEgoCube = new System.Windows.Forms.ToolBarButton();
            this.ilTooBar = new System.Windows.Forms.ImageList(this.components);
            this.sbMain = new System.Windows.Forms.StatusBar();
            this.sbPanelMain = new System.Windows.Forms.StatusBarPanel();
            this.pnlLeft = new System.Windows.Forms.Panel();
            this.tvHTMLDOM = new System.Windows.Forms.TreeView();
            this.ilTreeView = new System.Windows.Forms.ImageList(this.components);
            this.cmbFrame = new System.Windows.Forms.ComboBox();
            this.spterVirtical = new System.Windows.Forms.Splitter();
            this.pnlBottom = new System.Windows.Forms.Panel();
            this.lvInfo = new System.Windows.Forms.ListView();
            this.txtHTML = new System.Windows.Forms.TextBox();
            this.spterHorizontal = new System.Windows.Forms.Splitter();
            this.cmbAddress = new CP.Windows.Forms.URLComboBox();
            this.wbMain = new AxSHDocVw.AxWebBrowser();
            this.tmrSelector = new System.Windows.Forms.Timer(this.components);
            this.menuSP31 = new System.Windows.Forms.MenuItem();
            this.menuMove = new System.Windows.Forms.MenuItem();
            this.menuStop = new System.Windows.Forms.MenuItem();
            this.menuRefresh = new System.Windows.Forms.MenuItem();
            this.menuBack = new System.Windows.Forms.MenuItem();
            this.menuForward = new System.Windows.Forms.MenuItem();
            this.menuSP311 = new System.Windows.Forms.MenuItem();
            this.menuHome = new System.Windows.Forms.MenuItem();
            this.menuTextSize = new System.Windows.Forms.MenuItem();
            this.menuSP33 = new System.Windows.Forms.MenuItem();
            this.menuTextSizeG = new System.Windows.Forms.MenuItem();
            this.menuTextSizeL = new System.Windows.Forms.MenuItem();
            this.menuTextSizeM = new System.Windows.Forms.MenuItem();
            this.menuTextSizeS = new System.Windows.Forms.MenuItem();
            this.menuTextSizeA = new System.Windows.Forms.MenuItem();
            ((System.ComponentModel.ISupportInitialize)(this.sbPanelMain)).BeginInit();
            this.pnlLeft.SuspendLayout();
            this.pnlBottom.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.wbMain)).BeginInit();
            this.SuspendLayout();
            // 
            // menuMain
            // 
            this.menuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.menuFile,
                                                                                     this.menuEdit,
                                                                                     this.menuView,
                                                                                     this.menuHelp});
            // 
            // menuFile
            // 
            this.menuFile.Index = 0;
            this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.menuSave,
                                                                                     this.menuSaveAs,
                                                                                     this.menuSP11,
                                                                                     this.menuPageSetup,
                                                                                     this.menuPrint,
                                                                                     this.menuPrintPreview,
                                                                                     this.menuSP12,
                                                                                     this.menuOpenNavigationEventLog,
                                                                                     this.menuSP13,
                                                                                     this.menuProperty,
                                                                                     this.menuExit});
            this.menuFile.Text = "(&F)";
            this.menuFile.Click += new System.EventHandler(this.menuFile_Click);
            // 
            // menuSave
            // 
            this.menuSave.Index = 0;
            this.menuSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
            this.menuSave.Text = "(S)";
            this.menuSave.Click += new System.EventHandler(this.menuSave_Click);
            // 
            // menuSaveAs
            // 
            this.menuSaveAs.Index = 1;
            this.menuSaveAs.Text = "ٸ ̸ (&A)...";
            this.menuSaveAs.Click += new System.EventHandler(this.menuSaveAs_Click);
            // 
            // menuSP11
            // 
            this.menuSP11.Index = 2;
            this.menuSP11.Text = "-";
            // 
            // menuPageSetup
            // 
            this.menuPageSetup.Index = 3;
            this.menuPageSetup.Text = " (&U)...";
            this.menuPageSetup.Click += new System.EventHandler(this.menuPageSetup_Click);
            // 
            // menuPrint
            // 
            this.menuPrint.Index = 4;
            this.menuPrint.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
            this.menuPrint.Text = "μ(&P)...";
            this.menuPrint.Click += new System.EventHandler(this.menuPrint_Click);
            // 
            // menuPrintPreview
            // 
            this.menuPrintPreview.Index = 5;
            this.menuPrintPreview.Text = "μ ̸(&V)...";
            this.menuPrintPreview.Click += new System.EventHandler(this.menuPrintPreview_Click);
            // 
            // menuSP12
            // 
            this.menuSP12.Index = 6;
            this.menuSP12.Text = "-";
            // 
            // menuOpenNavigationEventLog
            // 
            this.menuOpenNavigationEventLog.Index = 7;
            this.menuOpenNavigationEventLog.Text = "׺̼ ̺Ʈ α  (&O)...";
            this.menuOpenNavigationEventLog.Click += new System.EventHandler(this.menuOpenNavigationEventLog_Click);
            // 
            // menuSP13
            // 
            this.menuSP13.Index = 8;
            this.menuSP13.Text = "-";
            // 
            // menuProperty
            // 
            this.menuProperty.Index = 9;
            this.menuProperty.Text = "Ӽ(&R)";
            this.menuProperty.Click += new System.EventHandler(this.menuProperty_Click);
            // 
            // menuExit
            // 
            this.menuExit.Index = 10;
            this.menuExit.Text = "ݱ(&C)";
            this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
            // 
            // menuEdit
            // 
            this.menuEdit.Index = 1;
            this.menuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.menuCut,
                                                                                     this.menuCopy,
                                                                                     this.menuPaste,
                                                                                     this.menuSP21,
                                                                                     this.menuSelectAll});
            this.menuEdit.Text = "(&E)";
            this.menuEdit.Popup += new System.EventHandler(this.menuEdit_Popup);
            // 
            // menuCut
            // 
            this.menuCut.Index = 0;
            this.menuCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
            this.menuCut.Text = "߶󳻱(&T)";
            this.menuCut.Click += new System.EventHandler(this.menuCut_Click);
            // 
            // menuCopy
            // 
            this.menuCopy.Index = 1;
            this.menuCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            this.menuCopy.Text = "(&C)";
            this.menuCopy.Click += new System.EventHandler(this.menuCopy_Click);
            // 
            // menuPaste
            // 
            this.menuPaste.Index = 2;
            this.menuPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            this.menuPaste.Text = "ٿֱ(&P)";
            this.menuPaste.Click += new System.EventHandler(this.menuPaste_Click);
            // 
            // menuSP21
            // 
            this.menuSP21.Index = 3;
            this.menuSP21.Text = "-";
            // 
            // menuSelectAll
            // 
            this.menuSelectAll.Index = 4;
            this.menuSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
            this.menuSelectAll.Text = " (&A)";
            this.menuSelectAll.Click += new System.EventHandler(this.menuSelectAll_Click);
            // 
            // menuView
            // 
            this.menuView.Index = 2;
            this.menuView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.menuMove,
                                                                                     this.menuStop,
                                                                                     this.menuRefresh,
                                                                                     this.menuSP31,
                                                                                     this.menuHTMLTag,
                                                                                     this.menuNavigationEventLog,
                                                                                     this.menuSP32,
                                                                                     this.menuTextSize,
                                                                                     this.menuSP33,
                                                                                     this.menuDOMTreeExpand,
                                                                                     this.menuSP34,
                                                                                     this.menuIEShow});
            this.menuView.Text = "(&V)";
            this.menuView.Click += new System.EventHandler(this.menuView_Click);
            // 
            // menuHTMLTag
            // 
            this.menuHTMLTag.Index = 4;
            this.menuHTMLTag.RadioCheck = true;
            this.menuHTMLTag.Text = "HTML ±(&T)";
            this.menuHTMLTag.Click += new System.EventHandler(this.menuHTMLTag_Click);
            // 
            // menuNavigationEventLog
            // 
            this.menuNavigationEventLog.Checked = true;
            this.menuNavigationEventLog.Index = 5;
            this.menuNavigationEventLog.RadioCheck = true;
            this.menuNavigationEventLog.Text = "׺̼ ̺Ʈ α(&L)";
            this.menuNavigationEventLog.Click += new System.EventHandler(this.menuNavigationEventLog_Click);
            // 
            // menuSP32
            // 
            this.menuSP32.Index = 6;
            this.menuSP32.Text = "-";
            // 
            // menuDOMTreeExpand
            // 
            this.menuDOMTreeExpand.Index = 9;
            this.menuDOMTreeExpand.Text = "DOM Ʈ Ȯ(&E)";
            this.menuDOMTreeExpand.Click += new System.EventHandler(this.menuDOMTreeExpand_Click);
            // 
            // menuSP34
            // 
            this.menuSP34.Index = 10;
            this.menuSP34.Text = "-";
            // 
            // menuIEShow
            // 
            this.menuIEShow.Index = 11;
            this.menuIEShow.Text = "ͳ ͽ÷η (&N)";
            this.menuIEShow.Click += new System.EventHandler(this.menuIEShow_Click);
            // 
            // menuHelp
            // 
            this.menuHelp.Index = 3;
            this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.menuHomepage,
                                                                                     this.menuDownload,
                                                                                     this.menuSP41,
                                                                                     this.menuAbout});
            this.menuHelp.Text = "(&H)";
            // 
            // menuHomepage
            // 
            this.menuHomepage.Index = 0;
            this.menuHomepage.Text = " Ȩ(&H)";
            this.menuHomepage.Click += new System.EventHandler(this.menuHomepage_Click);
            // 
            // menuDownload
            // 
            this.menuDownload.Index = 1;
            this.menuDownload.Text = "α׷ ٿε   ڷ(&D)";
            this.menuDownload.Click += new System.EventHandler(this.menuDownload_Click);
            // 
            // menuSP41
            // 
            this.menuSP41.Index = 2;
            this.menuSP41.Text = "-";
            // 
            // menuAbout
            // 
            this.menuAbout.Index = 3;
            this.menuAbout.Text = "EgoCube IE Analysis (&A)...";
            this.menuAbout.Click += new System.EventHandler(this.menuAbout_Click);
            // 
            // tbMain
            // 
            this.tbMain.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
            this.tbMain.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
                                                                                      this.tbBack,
                                                                                      this.tbForward,
                                                                                      this.tbStop,
                                                                                      this.tbRefresh,
                                                                                      this.tbHome,
                                                                                      this.tbSeparator01,
                                                                                      this.tbButton01,
                                                                                      this.tbButton02,
                                                                                      this.tbSeparator02,
                                                                                      this.tbExpandAll,
                                                                                      this.tbSeparator03,
                                                                                      this.tbExplorer,
                                                                                      this.tbSeparator04,
                                                                                      this.tbEgoCube});
            this.tbMain.DropDownArrows = true;
            this.tbMain.ImageList = this.ilTooBar;
            this.tbMain.Name = "tbMain";
            this.tbMain.ShowToolTips = true;
            this.tbMain.Size = new System.Drawing.Size(876, 25);
            this.tbMain.TabIndex = 0;
            this.tbMain.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbMain_ButtonClick);
            // 
            // tbBack
            // 
            this.tbBack.ImageIndex = 0;
            this.tbBack.Tag = "WB_BACK";
            this.tbBack.ToolTipText = "ڷ";
            // 
            // tbForward
            // 
            this.tbForward.ImageIndex = 1;
            this.tbForward.Tag = "WB_FORWARD";
            this.tbForward.ToolTipText = "";
            // 
            // tbStop
            // 
            this.tbStop.ImageIndex = 2;
            this.tbStop.Tag = "WB_STOP";
            this.tbStop.ToolTipText = "";
            // 
            // tbRefresh
            // 
            this.tbRefresh.ImageIndex = 3;
            this.tbRefresh.Tag = "WB_REFRESH";
            this.tbRefresh.ToolTipText = "ΰħ";
            // 
            // tbHome
            // 
            this.tbHome.ImageIndex = 4;
            this.tbHome.Tag = "WB_HOME";
            this.tbHome.ToolTipText = "Ȩ";
            // 
            // tbSeparator01
            // 
            this.tbSeparator01.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbButton01
            // 
            this.tbButton01.ImageIndex = 5;
            this.tbButton01.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
            this.tbButton01.Tag = "SHOW_HTML";
            this.tbButton01.ToolTipText = "HTML ±";
            // 
            // tbButton02
            // 
            this.tbButton02.ImageIndex = 6;
            this.tbButton02.Pushed = true;
            this.tbButton02.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
            this.tbButton02.Tag = "SHOW_EVENTLIST";
            this.tbButton02.ToolTipText = "׺̼ ̺Ʈ α";
            // 
            // tbSeparator02
            // 
            this.tbSeparator02.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbExpandAll
            // 
            this.tbExpandAll.ImageIndex = 7;
            this.tbExpandAll.Tag = "EXPAND_TREE_ALL";
            this.tbExpandAll.ToolTipText = "DOM Ʈ Ȯ";
            // 
            // tbSeparator03
            // 
            this.tbSeparator03.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbExplorer
            // 
            this.tbExplorer.ImageIndex = 8;
            this.tbExplorer.Tag = "EXPLORER";
            this.tbExplorer.ToolTipText = "ͳ ͽ÷η ";
            // 
            // tbSeparator04
            // 
            this.tbSeparator04.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbEgoCube
            // 
            this.tbEgoCube.ImageIndex = 9;
            this.tbEgoCube.Tag = "EGOCUBE";
            this.tbEgoCube.ToolTipText = " Ȩ";
            // 
            // ilTooBar
            // 
            this.ilTooBar.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this.ilTooBar.ImageSize = new System.Drawing.Size(16, 16);
            this.ilTooBar.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilTooBar.ImageStream")));
            this.ilTooBar.TransparentColor = System.Drawing.Color.Gray;
            // 
            // sbMain
            // 
            this.sbMain.Location = new System.Drawing.Point(0, 611);
            this.sbMain.Name = "sbMain";
            this.sbMain.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
                                                                                      this.sbPanelMain});
            this.sbMain.ShowPanels = true;
            this.sbMain.Size = new System.Drawing.Size(876, 22);
            this.sbMain.TabIndex = 4;
            // 
            // sbPanelMain
            // 
            this.sbPanelMain.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
            this.sbPanelMain.Width = 860;
            // 
            // pnlLeft
            // 
            this.pnlLeft.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                                  this.tvHTMLDOM,
                                                                                  this.cmbFrame});
            this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Left;
            this.pnlLeft.Location = new System.Drawing.Point(0, 25);
            this.pnlLeft.Name = "pnlLeft";
            this.pnlLeft.Size = new System.Drawing.Size(200, 586);
            this.pnlLeft.TabIndex = 5;
            // 
            // tvHTMLDOM
            // 
            this.tvHTMLDOM.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tvHTMLDOM.ImageList = this.ilTreeView;
            this.tvHTMLDOM.Indent = 16;
            this.tvHTMLDOM.ItemHeight = 18;
            this.tvHTMLDOM.Location = new System.Drawing.Point(0, 20);
            this.tvHTMLDOM.Name = "tvHTMLDOM";
            this.tvHTMLDOM.Size = new System.Drawing.Size(200, 566);
            this.tvHTMLDOM.TabIndex = 1;
            this.tvHTMLDOM.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvHTMLDOM_AfterSelect);
            // 
            // ilTreeView
            // 
            this.ilTreeView.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
            this.ilTreeView.ImageSize = new System.Drawing.Size(16, 16);
            this.ilTreeView.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilTreeView.ImageStream")));
            this.ilTreeView.TransparentColor = System.Drawing.Color.Gray;
            // 
            // cmbFrame
            // 
            this.cmbFrame.Dock = System.Windows.Forms.DockStyle.Top;
            this.cmbFrame.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbFrame.DropDownWidth = 200;
            this.cmbFrame.Enabled = false;
            this.cmbFrame.MaxDropDownItems = 10;
            this.cmbFrame.Name = "cmbFrame";
            this.cmbFrame.Size = new System.Drawing.Size(200, 20);
            this.cmbFrame.TabIndex = 0;
            this.cmbFrame.SelectedIndexChanged += new System.EventHandler(this.cmbFrame_SelectedIndexChanged);
            // 
            // spterVirtical
            // 
            this.spterVirtical.Location = new System.Drawing.Point(200, 25);
            this.spterVirtical.MinExtra = 300;
            this.spterVirtical.MinSize = 180;
            this.spterVirtical.Name = "spterVirtical";
            this.spterVirtical.Size = new System.Drawing.Size(3, 586);
            this.spterVirtical.TabIndex = 6;
            this.spterVirtical.TabStop = false;
            // 
            // pnlBottom
            // 
            this.pnlBottom.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                                    this.lvInfo,
                                                                                    this.txtHTML});
            this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.pnlBottom.Location = new System.Drawing.Point(203, 491);
            this.pnlBottom.Name = "pnlBottom";
            this.pnlBottom.Size = new System.Drawing.Size(673, 120);
            this.pnlBottom.TabIndex = 7;
            // 
            // lvInfo
            // 
            this.lvInfo.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lvInfo.Font = new System.Drawing.Font("", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(129)));
            this.lvInfo.FullRowSelect = true;
            this.lvInfo.LabelWrap = false;
            this.lvInfo.MultiSelect = false;
            this.lvInfo.Name = "lvInfo";
            this.lvInfo.Size = new System.Drawing.Size(673, 120);
            this.lvInfo.TabIndex = 2;
            this.lvInfo.View = System.Windows.Forms.View.List;
            // 
            // txtHTML
            // 
            this.txtHTML.BackColor = System.Drawing.Color.White;
            this.txtHTML.Dock = System.Windows.Forms.DockStyle.Fill;
            this.txtHTML.Multiline = true;
            this.txtHTML.Name = "txtHTML";
            this.txtHTML.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.txtHTML.Size = new System.Drawing.Size(673, 120);
            this.txtHTML.TabIndex = 1;
            this.txtHTML.Text = "";
            // 
            // spterHorizontal
            // 
            this.spterHorizontal.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.spterHorizontal.Location = new System.Drawing.Point(203, 488);
            this.spterHorizontal.MinExtra = 300;
            this.spterHorizontal.MinSize = 120;
            this.spterHorizontal.Name = "spterHorizontal";
            this.spterHorizontal.Size = new System.Drawing.Size(673, 3);
            this.spterHorizontal.TabIndex = 8;
            this.spterHorizontal.TabStop = false;
            // 
            // cmbAddress
            // 
            this.cmbAddress.Dock = System.Windows.Forms.DockStyle.Top;
            this.cmbAddress.Flags = ((CP.Windows.Forms.AutoCompleteFlags.FileSystem | CP.Windows.Forms.AutoCompleteFlags.URLHistory) 
                | CP.Windows.Forms.AutoCompleteFlags.URLMRU);
            this.cmbAddress.Location = new System.Drawing.Point(203, 25);
            this.cmbAddress.MRUKey = "Software\\Microsoft\\Internet Explorer\\TypedURLs";
            this.cmbAddress.MRUKeyHive = CP.Windows.Forms.MRUKeyHive.CurrentUser;
            this.cmbAddress.Name = "cmbAddress";
            this.cmbAddress.Size = new System.Drawing.Size(673, 20);
            this.cmbAddress.TabIndex = 10;
            this.cmbAddress.KeyDown += new System.Windows.Forms.KeyEventHandler(this.cmbAddress_KeyDown);
            // 
            // wbMain
            // 
            this.wbMain.Dock = System.Windows.Forms.DockStyle.Fill;
            this.wbMain.Enabled = true;
            this.wbMain.Location = new System.Drawing.Point(203, 45);
            this.wbMain.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("wbMain.OcxState")));
            this.wbMain.Size = new System.Drawing.Size(673, 443);
            this.wbMain.TabIndex = 11;
            this.wbMain.StatusTextChange += new AxSHDocVw.DWebBrowserEvents2_StatusTextChangeEventHandler(this.wbMain_StatusTextChange);
            this.wbMain.DownloadBegin += new System.EventHandler(this.wbMain_DownloadBegin);
            this.wbMain.CommandStateChange += new AxSHDocVw.DWebBrowserEvents2_CommandStateChangeEventHandler(this.wbMain_CommandStateChange);
            this.wbMain.DownloadComplete += new System.EventHandler(this.wbMain_DownloadComplete);
            this.wbMain.TitleChange += new AxSHDocVw.DWebBrowserEvents2_TitleChangeEventHandler(this.wbMain_TitleChange);
            this.wbMain.NavigateComplete2 += new AxSHDocVw.DWebBrowserEvents2_NavigateComplete2EventHandler(this.wbMain_NavigateComplete2);
            this.wbMain.DocumentComplete += new AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEventHandler(this.wbMain_DocumentComplete);
            // 
            // tmrSelector
            // 
            this.tmrSelector.Interval = 50;
            this.tmrSelector.Tick += new System.EventHandler(this.tmrSelector_Tick);
            // 
            // menuSP31
            // 
            this.menuSP31.Index = 3;
            this.menuSP31.Text = "-";
            // 
            // menuMove
            // 
            this.menuMove.Index = 0;
            this.menuMove.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                     this.menuBack,
                                                                                     this.menuForward,
                                                                                     this.menuSP311,
                                                                                     this.menuHome});
            this.menuMove.Text = "̵(&O)";
            // 
            // menuStop
            // 
            this.menuStop.Index = 1;
            this.menuStop.Text = "(&P)";
            this.menuStop.Click += new System.EventHandler(this.menuStop_Click);
            // 
            // menuRefresh
            // 
            this.menuRefresh.Index = 2;
            this.menuRefresh.Shortcut = System.Windows.Forms.Shortcut.F5;
            this.menuRefresh.Text = " ħ(&R)";
            this.menuRefresh.Click += new System.EventHandler(this.menuRefresh_Click);
            // 
            // menuBack
            // 
            this.menuBack.Enabled = false;
            this.menuBack.Index = 0;
            this.menuBack.Text = "ڷ(&B)";
            this.menuBack.Click += new System.EventHandler(this.menuBack_Click);
            // 
            // menuForward
            // 
            this.menuForward.Enabled = false;
            this.menuForward.Index = 1;
            this.menuForward.Text = "(&F)";
            this.menuForward.Click += new System.EventHandler(this.menuForward_Click);
            // 
            // menuSP311
            // 
            this.menuSP311.Index = 2;
            this.menuSP311.Text = "-";
            // 
            // menuHome
            // 
            this.menuHome.Index = 3;
            this.menuHome.Text = "Ȩ (H)";
            this.menuHome.Click += new System.EventHandler(this.menuHome_Click);
            // 
            // menuTextSize
            // 
            this.menuTextSize.Index = 7;
            this.menuTextSize.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                         this.menuTextSizeG,
                                                                                         this.menuTextSizeL,
                                                                                         this.menuTextSizeM,
                                                                                         this.menuTextSizeS,
                                                                                         this.menuTextSizeA});
            this.menuTextSize.Text = "ؽƮ ũ(&X)";
            this.menuTextSize.Popup += new System.EventHandler(this.menuTextSize_Popup);
            // 
            // menuSP33
            // 
            this.menuSP33.Index = 8;
            this.menuSP33.Text = "-";
            // 
            // menuTextSizeG
            // 
            this.menuTextSizeG.Index = 0;
            this.menuTextSizeG.RadioCheck = true;
            this.menuTextSizeG.Text = " ũ(G)";
            this.menuTextSizeG.Click += new System.EventHandler(this.menuTextSizeG_Click);
            // 
            // menuTextSizeL
            // 
            this.menuTextSizeL.Index = 1;
            this.menuTextSizeL.RadioCheck = true;
            this.menuTextSizeL.Text = "ũ(&L)";
            this.menuTextSizeL.Click += new System.EventHandler(this.menuTextSizeL_Click);
            // 
            // menuTextSizeM
            // 
            this.menuTextSizeM.Index = 2;
            this.menuTextSizeM.RadioCheck = true;
            this.menuTextSizeM.Text = "(&M)";
            this.menuTextSizeM.Click += new System.EventHandler(this.menuTextSizeM_Click);
            // 
            // menuTextSizeS
            // 
            this.menuTextSizeS.Index = 3;
            this.menuTextSizeS.RadioCheck = true;
            this.menuTextSizeS.Text = "۰(&S)";
            this.menuTextSizeS.Click += new System.EventHandler(this.menuTextSizeS_Click);
            // 
            // menuTextSizeA
            // 
            this.menuTextSizeA.Index = 4;
            this.menuTextSizeA.RadioCheck = true;
            this.menuTextSizeA.Text = " ۰(A)";
            this.menuTextSizeA.Click += new System.EventHandler(this.menuTextSizeA_Click);
            // 
            // frmMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
            this.AutoScroll = true;
            this.ClientSize = new System.Drawing.Size(876, 633);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.wbMain,
                                                                          this.cmbAddress,
                                                                          this.spterHorizontal,
                                                                          this.pnlBottom,
                                                                          this.spterVirtical,
                                                                          this.pnlLeft,
                                                                          this.sbMain,
                                                                          this.tbMain});
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.menuMain;
            this.Name = "frmMain";
            this.Text = "EgoCube IE Analysis 0.0.2";
            this.Load += new System.EventHandler(this.frmMain_Load);
            ((System.ComponentModel.ISupportInitialize)(this.sbPanelMain)).EndInit();
            this.pnlLeft.ResumeLayout(false);
            this.pnlBottom.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.wbMain)).EndInit();
            this.ResumeLayout(false);

        }

		#endregion

        #region Custom Utility Function Code

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.19
        //* 
        //*   : 2004.03.19
        //* 
        //*     : ؽƮ α  ޸ Ǵ ϵ  α׷ Ͽ 
        //*           մϴ.
        //*
        //*******************************************************************************

        /// <summary>
        /// ؽƮ α  ޸ Ǵ ϵ  α׷ Ͽ մϴ.
        /// </summary>
        private void OpenTextLog() 
        {
            this.Cursor = Cursors.WaitCursor;

            RegistryKey objRegistryKey = Registry.ClassesRoot.OpenSubKey(@"txtfile\shell\open\command");
            string strLocation = (string) objRegistryKey.GetValue("");
            strLocation = strLocation.Replace("%1", "").Trim();

            Process.Start(strLocation, DateTime.Now.ToString("yyyyMMdd") + ".txt");

            this.Cursor = Cursors.Default;
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.18
        //* 
        //*   : 2004.03.18
        //* 
        //*     : yyyyMMdd.log   α Ͽ strLogContent ڷ  α
        //*            մϴ. α  α׷   ϴ 
        //*            ڵ ˴ϴ.
        //*
        //*******************************************************************************

        /// <summary>
        /// yyyyMMdd.log   α Ͽ strLogContent ڷ  α  մϴ.
        /// </summary>
        /// <param name="strLogContent">α </param>
        private void WriteTextLog(string strLogContent) 
        {
            this.objStreamWriter.WriteLine(strLogContent);
            this.objStreamWriter.Flush();
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.15
        //* 
        //*   : 2004.03.18
        //* 
        //*     :  Ȩ EgoCube Ȩ (http://www.egocube.pe.kr/) 
        //*           Ÿ   ͳ ͽ÷η մϴ.
        //*
        //*******************************************************************************

        /// <summary>
        ///  Ȩ EgoCube Ȩ  Ÿ   ͳ ͽ÷η մϴ.
        /// </summary>
        private void OpenEgoCube(string strType)
        {
            this.Cursor = Cursors.WaitCursor;
            strType = strType.ToUpper();

            RegistryKey objRegistryKey = Registry.ClassesRoot.OpenSubKey(@"http\shell\open\command");
            string strIELocation = (string) objRegistryKey.GetValue("");

            int iPosition = strIELocation.IndexOf("-");
            if (iPosition > -1) 
                strIELocation = strIELocation.Substring(0, iPosition - 1);
            if (strIELocation.Substring(0, 1) == "\"") 
                strIELocation = strIELocation.Substring(1, strIELocation.Length - 1);
            if (strIELocation.Substring(strIELocation.Length - 1, 1) == "\"") 
                strIELocation = strIELocation.Substring(0, strIELocation.Length - 1);

            if (strType == "HOME")
                Process.Start(strIELocation, "http://www.egocube.pe.kr/");
            else if (strType == "DOWNLOAD")
                Process.Start(strIELocation, "http://www.egocube.pe.kr/asp_0014.asp");

            this.Cursor = Cursors.Default;
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.09
        //* 
        //*   : 2004.03.09
        //* 
        //*     : Ʈ ͳ ͽ÷η ġ θ ã  URL  
        //*           ͳ ͽ÷η մϴ.
        //*
        //*******************************************************************************

        /// <summary>
        ///  IE Analysis  ε URL  ͳ ͽ÷η ٽ մϴ.
        /// </summary>
        private void OpenInternetExplorer()
        {
            this.Cursor = Cursors.WaitCursor;

            RegistryKey objRegistryKey = Registry.ClassesRoot.OpenSubKey(@"http\shell\open\command");
            string strIELocation = (string) objRegistryKey.GetValue("");

            int iPosition = strIELocation.IndexOf("-");
            if (iPosition > -1) 
                strIELocation = strIELocation.Substring(0, iPosition - 1);
            if (strIELocation.Substring(0, 1) == "\"") 
                strIELocation = strIELocation.Substring(1, strIELocation.Length - 1);
            if (strIELocation.Substring(strIELocation.Length - 1, 1) == "\"") 
                strIELocation = strIELocation.Substring(0, strIELocation.Length - 1);

            Process.Start(strIELocation, this.wbMain.LocationURL);

            this.Cursor = Cursors.Default;
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.25
        //* 
        //*     :  ε HTML  DOM Ʈ  Ľ ϴ ޼ҵԴϴ.
        //*             HTML  mshtml.IHTMLDocument2 ü ޼ҵ ڷ 
        //*           Է¹޾ ʿ   ó ۾ óϰ   Ŀú ޼
        //*            HTMLTagTrace() ޼ҵ带 ȣϿ  Ľ ۾ մ
        //*           . ׸  HTMLTagTrace() ޼ҵ尡 Ǹ tvHTMLDOM Ʈ
        //*            Ʈѿ  HTML ±  Ȯմϴ.
        //*
        //*******************************************************************************

        /// <summary>
        ///  ε HTML  DOM Ʈ  Ľ մϴ.
        /// </summary>
        /// <param name="objDocument2"> HTML  mshtml.IHTMLDocument2 ü</param>
        private void HTMLTagTraceHolder(mshtml.IHTMLDocument2 objDocument2)
        {
            object oElement;
            object oEmpty = Type.Missing;

            int iCollectionCount    = 0;
            int iSubCollectionCount = 0;
            

            //***************************************************************************
            //* ֻ  HTML ±׵ óϰų Ŀú ޼ҵ HTMLTagTrace() 
            //* ޼ҵ带 ȣѴ.
            //***************************************************************************

            this.tvHTMLDOM.BeginUpdate();
            iCollectionCount = objDocument2.all.length;
            for (int i = 0; i < iCollectionCount; i++)
            {
                this.sbMain.Panels[0].Text = " DOM Ʈ  м ...";

                oElement = i;
                mshtml.IHTMLElement objElement = objDocument2.all.item(oElement, oEmpty) as mshtml.IHTMLElement;
                if (objElement != null)
                {
                    string strTAG = objElement.tagName;
                    if (strTAG == "HTML")
                    {
                        //** Ŀú ޼ҵ HTMLTagTrace() ޼ҵ带 ȣѴ.
                        this.txtHTML.Text = objElement.innerHTML.Replace("\n", System.Environment.NewLine).Replace("\r\r\n", System.Environment.NewLine);
                        HTMLTagTrace(objElement, null);
                        break;
                    }
                    else
                    {
                        //** Ÿ ֻ HTML ± ó 
                        //** ). <!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN">
                        TreeNode objTreeNode = new TreeNode(strTAG, GetNodeImageIndex(strTAG, ""), GetNodeImageIndex(strTAG, ""));
                        objTreeNode.Tag = objElement.sourceIndex.ToString();
                        this.tvHTMLDOM.Nodes.Add(objTreeNode);
                    }
                }
            }


            //***************************************************************************
            //* HTML ±, FRAMESET ±  ȮѴ.
            //***************************************************************************
            
            iCollectionCount = this.tvHTMLDOM.Nodes.Count;
            for (int i = 0; i < iCollectionCount; i++)
            {
                if (this.tvHTMLDOM.Nodes[i].Text == "HTML")
                {
                    this.tvHTMLDOM.Nodes[i].Expand();
                    iSubCollectionCount = this.tvHTMLDOM.Nodes[i].Nodes.Count;
                    for (int j = 0; j < iSubCollectionCount; j++)
                    {
                        if (this.tvHTMLDOM.Nodes[i].Nodes[j].Text == "FRAMESET")
                        {
                            this.tvHTMLDOM.Nodes[i].Nodes[j].Expand();
                        }
                    }
                    break;
                }
            }

            this.tvHTMLDOM.Nodes[0].EnsureVisible();
            this.tvHTMLDOM.EndUpdate();
            this.sbMain.Panels[0].Text = "Ϸ";

            return;
        }
        
        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.25
        //* 
        //*     :  ޼ҵ Ŀú ޼ҵԴϴ. HTMLTagTraceHolder() żҵ忡 
        //*           ؼ ʱ ȣǸ  ʹ   ȣ˴ϴ.  ٸ 
        //*           ƿƼ ޼ҵ GetNodeImageIndex() ޼ҵ带 Ͽ ڷ Ѿ
        //*           HTML ±׿ ˸ Ʈ Ʈ  ̹ Ʈ ε 
        //*             忡   tvHTMLDOM Ʈ Ʈѿ ߰մϴ.  
        //*            HTML ±װ FRAME ± Ǵ IFRAME ±  cmbFrame ޺
        //*            Ʈѿ   մϴ.
        //*           
        //*******************************************************************************
        
        /// <summary>
        ///  ȣ ϸ鼭 tvHTMLDOM Ʈ Ʈѿ  HTML ±׿ ϴ Ʈ 带 ߰մϴ.
        /// </summary>
        /// <param name="objElement">HTML ± mshtml.IHTMLElement ü</param>
        /// <param name="objParentNode">θ  TreeNode ü</param>
        private void HTMLTagTrace(mshtml.IHTMLElement objElement, TreeNode objParentNode)
        {
            int iIndex;
            string strTAG  = objElement.tagName;
            string strType = "";
            

            //***************************************************************************
            //* ش  Ʈ  ϰ FRAME ± Ǵ IFRAME ±  
            //* cmbFrame ޺ڽ Ʈѿ ش  Ѵ.
            //***************************************************************************
            
            try
            {
                strType = objElement.getAttribute("TYPE", 0).ToString();
            }
            catch (Exception Ex)
            {
                strType = "";
            }
            iIndex = GetNodeImageIndex(strTAG, strType.ToUpper());

            if (strTAG == "FRAME" || strTAG == "IFRAME")
            {
                string strURL  = "";

                strURL = GetFramedURL(objElement).Trim();
                if (strURL == "")
                    this.cmbFrame.Items.Add("<" + strTAG + "> about:blank");
                else
                    this.cmbFrame.Items.Add("<" + strTAG + "> " + GetFramedURL(objElement));
            }
            

            //***************************************************************************
            //* tvHTMLDOM Ʈ Ʈѿ  HTML ± ο 带 ߰Ѵ.
            //***************************************************************************
            
            if (strTAG == "INPUT") strTAG += " : " + strType.ToUpper();
            TreeNode objTreeNode = new TreeNode(strTAG, iIndex, iIndex);
            objTreeNode.Tag = objElement.sourceIndex.ToString();

            if (objParentNode == null) 
                this.tvHTMLDOM.Nodes.Add(objTreeNode);
            else
                objParentNode.Nodes.Add(objTreeNode);


            //***************************************************************************
            //* ٽ  HTML ± ڽ ±׵鿡 Ͽ  ȣ ó.
            //***************************************************************************

            mshtml.IHTMLElementCollection objElementCollection = objElement.children as mshtml.IHTMLElementCollection;
            if (objElementCollection != null)
            {
                int iElementCnt = objElementCollection.length;
                for (int i = 0; i < iElementCnt; i++)
                {
                    object oElement = i;
                    object oEmpty = Type.Missing;
                    mshtml.IHTMLElement objElementChild = objElementCollection.item(oElement, oEmpty) as mshtml.IHTMLElement;
                    if (objElementChild != null)
                    {
                        HTMLTagTrace(objElementChild, objTreeNode);
                    }
                }
            }

            return;
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.10
        //* 
        //*     :  HTML ±׿ ˸´ ̹ Ʈ ε մϴ. 
        //*           ϵ  ilTreeView ̹ Ʈ ƮѰ ˴ϴ.
        //*           
        //*******************************************************************************
        
        /// <summary>
        ///  HTML ±׿ ˸´ ̹ Ʈ ε ݴϴ.
        /// </summary>
        /// <param name="strTAG">HTML ± ̸ ڿ</param>
        /// <param name="strType">HTML ± type ƮƮ ڿ</param>
        /// <returns>Ʈ 忡  ̹ Ʈ ε</returns>
        private int GetNodeImageIndex(string strTAG, string strType)
        {
            int iIndex = 0;
            int iBase  = 53;

            switch (strTAG)
            {
                case "IMG":      iIndex = 1;  break;
                case "TABLE":    iIndex = 2;  break;
                case "TBODY":    iIndex = 3;  break;
                case "TR":       iIndex = 4;  break;
                case "TD":       iIndex = 5;  break;
                case "B":        iIndex = 6;  break;
                case "STRONG":   iIndex = 6;  break;
                case "I":        iIndex = 7;  break;
                case "U":        iIndex = 8;  break;
                case "META":     iIndex = 9;  break;
                case "SCRIPT":   iIndex = 10; break;
                case "FONT":     iIndex = 11; break;
                case "STYLE":    iIndex = 12; break;
                case "CENTER":   iIndex = 13; break;
                case "TITLE":    iIndex = 14; break;
                case "FORM":     iIndex = 15; break;
                case "!":        iIndex = 16; break;
                case "SPAN":     iIndex = 17; break;
                case "DIV":      iIndex = 18; break;
                case "A":        iIndex = 19; break;
                case "BR":       iIndex = 20; break;
                case "OBJECT":   iIndex = 21; break;
                case "LINK":     iIndex = 22; break;
                case "BODY":     iIndex = 23; break;
                case "HEAD":     iIndex = 24; break;
                case "HTML":     iIndex = 25; break;
                case "FRAME":    iIndex = 26; break;
                case "FRAMESET": iIndex = 26; break;
                case "IFRAME":   iIndex = 27; break;
                case "HR":       iIndex = 28; break;
                case "SELECT":   iIndex = 29; break;
                case "OPTION":   iIndex = 30; break;
                case "P":        iIndex = 31; break;
                case "MAP":      iIndex = 32; break;
                case "AREA":     iIndex = 33; break;
                case "TEXTAREA": iIndex = 34; break;
                case "NOFRAMES": iIndex = 35; break;
                case "LABEL":    iIndex = 36; break;
                case "H1":       iIndex = 37; break;
                case "H2":       iIndex = 38; break;
                case "H3":       iIndex = 39; break;
                case "H4":       iIndex = 40; break;
                case "H5":       iIndex = 41; break;
                case "H6":       iIndex = 42; break;
                case "NOBR":     iIndex = 43; break;
                case "WBR":      iIndex = 44; break;
                case "LAYER":    iIndex = 45; break;
                case "ILAYER":   iIndex = 45; break;
                case "UL":       iIndex = 46; break;
                case "LI":       iIndex = 47; break;
                case "OL":       iIndex = 48; break;
                case "NOSCRIPT": iIndex = 49; break;
                case "SUB":      iIndex = 50; break;
                case "SUP":      iIndex = 51; break;
                case "BASE":     iIndex = 52; break;
                case "INPUT": 
                    if (strType == "TEXT") 
                        iIndex = iBase;
                    else if (strType == "CHECKBOX")
                        iIndex = iBase + 1;
                    else if (strType == "HIDDEN")
                        iIndex = iBase + 2;
                    else if (strType == "PASSWORD")
                        iIndex = iBase + 3;
                    else if (strType == "IMAGE")
                        iIndex = iBase + 4;
                    else if (strType == "BUTTON")
                        iIndex = iBase + 5;
                    else if (strType == "SUBMIT")
                        iIndex = iBase + 6;
                    else if (strType == "RESET")
                        iIndex = iBase + 7;
                    else if (strType == "RADIO")
                        iIndex = iBase + 8;
                    else
                        iIndex = 0;
                    break;
                default:         iIndex = 0;  break;
            }

            return iIndex;
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.25
        //* 
        //*     : tbMain  Ʈ ư Ŭ  ۾ ܼϰ ϱ 
        //*            ˴ϴ.
        //*
        //*******************************************************************************

        /// <summary>
        /// tbMain  Ʈ ư Ŭ  ۾ ܼϰ ϱ ؼ ˴ϴ.
        /// </summary>
        /// <param name="enumType">۾  ϱ  ToolBarButtonState </param>
        private void SetToolBarButtonState(ToolBarButtonState enumType)
        {
            switch (enumType)
            {
                case ToolBarButtonState.HTML:
                    
                    tbMain.Buttons[6].Pushed = true;
                    tbMain.Buttons[7].Pushed = false;
                    menuHTMLTag.Checked = true;
                    menuNavigationEventLog.Checked = false;
                    lvInfo.Visible = false;
                    txtHTML.Visible = true;
                    break;

                case ToolBarButtonState.EventList:

                    tbMain.Buttons[6].Pushed = false;
                    tbMain.Buttons[7].Pushed = true;
                    menuHTMLTag.Checked = false;
                    menuNavigationEventLog.Checked = true;
                    lvInfo.Visible = true;
                    txtHTML.Visible = false;
                    break;
            }
        }
        
        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.18
        //* 
        //*   : 2004.03.18
        //* 
        //*     : lvInfo Ʈ ƮѰ α Ͽ ׺̼ ̺Ʈ α׸ 
        //*           մϴ.       αװ ˴ϴ.
        //*           - ̺Ʈ      : MessageType.Event
        //*           - α׷ ޼ : MessageType.Message
        //*           -       : MessageType.Information
        //*           - Ű        : MessageType.Cookie
        //*           -         : MessageType.HeaderHeader
        //*           - ˾â      : MessageType.Window
        //*           
        //*******************************************************************************

        /// <summary>
        /// lvInfo Ʈ ƮѰ α Ͽ ׺̼ ̺Ʈ α׸ մϴ.
        /// </summary>
        /// <param name="strType">  ϱ  MessageType . '' ׸ </param>
        /// <param name="strEvent"> . '' ׸ </param>
        /// <param name="strURL"> HTML  URL. 'URL' ׸ </param>
        private void navigationLogWrite(MessageType enumType, string strEvent, string strURL)
        {
            string strLogType = "";
            int iCount = lvInfo.Items.Count;
            
            this.lvInfo.BeginUpdate();

            //** ׺̼ ̺Ʈ α  ׻ 512  Ϸ 
            if (iCount >= 512)
            {
                this.lvInfo.Items.Remove(this.lvInfo.Items[0]);
                iCount = lvInfo.Items.Count;
            }

            //** lvInfo Ʈ Ʈѿ ׺̼ ̺Ʈ α 
            this.lvInfo.Items.Add(DateTime.Now.ToString("HH':'mm':'ss'.'ffff"));

            if (enumType == MessageType.Event)
            {
                this.lvInfo.Items[iCount].SubItems.Add("̺Ʈ ");
                this.lvInfo.Items[iCount].BackColor = Color.FromArgb(240, 240, 255);
                strLogType = "̺Ʈ ";
            }
            else if (enumType == MessageType.Message)
            {
                this.lvInfo.Items[iCount].SubItems.Add("α׷ ޼");
                this.lvInfo.Items[iCount].BackColor = Color.FromArgb(255, 240, 240);
                strLogType = "α׷ ޼";
            }
            else if (enumType == MessageType.Information)
            {
                this.lvInfo.Items[iCount].SubItems.Add(" ");
                this.lvInfo.Items[iCount].BackColor = Color.FromArgb(240, 255, 240);
                strLogType = " ";
            }
            else if (enumType == MessageType.Cookie)
            {
                this.lvInfo.Items[iCount].SubItems.Add("Ű ");
                this.lvInfo.Items[iCount].BackColor = Color.FromArgb(210, 255, 255);
                strLogType = "Ű ";
            }
            else if (enumType == MessageType.Header)
            {
                this.lvInfo.Items[iCount].SubItems.Add(" ");
                this.lvInfo.Items[iCount].BackColor = Color.FromArgb(255, 210, 255);
                strLogType = " ";
            }
            else if (enumType == MessageType.Window)
            {
                this.lvInfo.Items[iCount].SubItems.Add("˾â ");
                this.lvInfo.Items[iCount].BackColor = Color.FromArgb(255, 255, 210);
                strLogType = "˾â ";
            }

            this.lvInfo.Items[iCount].SubItems.Add(strEvent);
            this.lvInfo.Items[iCount].SubItems.Add(strURL);
            this.lvInfo.Items[iCount].EnsureVisible();
            
            this.lvInfo.EndUpdate();

            //** α Ͽ ׺̼ ̺Ʈ α 
            this.WriteTextLog(DateTime.Now.ToString("HH':'mm':'ss'.'ffff") + "\t" + strLogType + "\t" + strEvent + "\t" + strURL);
        }

        //*******************************************************************************
        //* 
        //*     : ƿƼ ޼ҵ
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.02
        //* 
        //*   : 2004.03.10
        //* 
        //*     : FRMAE ± Ǵ IFRAME ± src ƮƮ  URL ڿ 
        //*            ε HTML  URL ڿ Ͽ ȿ URL  
        //*            ڿ  մϴ.  ó    
        //*           ϴ.
        //*           - /       ڿ ϴ URL 
        //*           - ./      ڿ ϴ URL 
        //*           - ../     ڿ ϴ URL 
        //*           - http:// ڿ ϴ URL 
        //*           -  쿡 ش ʴ URL 
        //*           
        //*******************************************************************************

        /// <summary>
        /// FRMAE ± Ǵ IFRAME ±׿  URL  ãƼ ڿ մϴ.
        /// </summary>
        /// <param name="objElement">FRMAE ± Ǵ IFRAME ± mshtml.IHTMLElement ü</param>
        /// <returns></returns>
        private string GetFramedURL(mshtml.IHTMLElement objElement)
        {
            string strURL = "";

            mshtml.IHTMLDocument2 objDocument2 = (IHTMLDocument2) this.wbMain.Document;
            try
            {
                string strFrameURL = objElement.getAttribute("src", 0).ToString();

                if (strFrameURL.Substring(0, 2) == "./") 
                {
                    //** ./ ڿ ϴ URL 
                    strFrameURL = strFrameURL.Substring(2, strFrameURL.Length - 2);
                }
                        
                if (strFrameURL.Substring(0, 1) == "/")
                {
                    //** / ڿ ϴ URL 
                    strURL = "http://" + objDocument2.location.host + strFrameURL;
                }
                else if (strFrameURL.Substring(0, 3).ToLower() == "../")
                {
                    //** ../ ڿ ϴ URL 
                    string strLocation = objDocument2.location.href;
                    string [] aryTemp  = strLocation.Split('/');
                    string strBuffer   = "";

                    int iStart = 0;
                    int iCnt   = 0;
            
                    for (int i = 1; i > 0; i++)
                    {
                        iStart = strFrameURL.IndexOf("../", iStart);
                        if (iStart == -1)
                        {
                            break;
                        }
                        else
                        {
                            iStart += 3;
                            iCnt++;
                        }
                    }
                    strFrameURL = strFrameURL.Replace("../", "");

                    for (int i = 0; i < aryTemp.Length - iCnt - 1; i++) strBuffer += aryTemp[i] + "/";
                    strURL = strBuffer + strFrameURL;
                }
                else if (strFrameURL.Substring(0, 7).ToLower() == "http://")
                {
                    //** http:// ڿ ϴ URL 
                    strURL = strFrameURL;
                }
                else
                {
                    //**  쿡 ش ʴ URL 
                    string strLocation = objDocument2.location.href;
                    int iLength = strFrameURL.Length - objDocument2.location.pathname.Length + 1;

                    if (strLocation.IndexOf("?") > -1)
                        strLocation = strLocation.Substring(0, strLocation.IndexOf("?"));

                    if (strLocation.Substring(strLocation.Length - 1 , 1) != "/")
                        strLocation = strLocation.Substring(0, strLocation.LastIndexOf("/") + 1);

                    strURL = strLocation + strFrameURL;
                }

                return strURL;
            }
            catch (Exception Ex)
            {
                return "";
            }
        }

        #endregion

        #region WebBrowser Control Event Handler Code

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.25
        //* 
        //*     :  ׺̼ ̺Ʈ α׸ lvInfo Ʈ Ʈѿ մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ DownloadBegin ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_DownloadBegin(object sender, System.EventArgs e)
        {
            this.navigationLogWrite(MessageType.Event, "ͳ ͽ÷η DownloadBegin ̺Ʈ ߻Ǿϴ.", "");
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.25
        //* 
        //*     :  ׺̼ ̺Ʈ α׸ lvInfo Ʈ Ʈѿ մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ DownloadComplete ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_DownloadComplete(object sender, System.EventArgs e)
        {
            this.navigationLogWrite(MessageType.Event, "ͳ ͽ÷η DownloadComplete ̺Ʈ ߻Ǿϴ.", "");
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.02.25
        //* 
        //*     :  ׺̼ ̺Ʈ α׸ lvInfo Ʈ Ʈѿ մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ NavigateComplete2 ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_NavigateComplete2(object sender, AxSHDocVw.DWebBrowserEvents2_NavigateComplete2Event e)
        {
            this.navigationLogWrite(MessageType.Event, "ͳ ͽ÷η NavigateComplete2 ̺Ʈ ߻Ǿϴ.", e.uRL.ToString());
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.22
        //* 
        //*     :  ¿ ˸ ׺̼ ̺Ʈ α׸ lvInfo Ʈ Ʈѿ
        //*           մϴ.  ̺Ʈ ߻Ų HTML  ֻ HTML  
        //*           쿡 DOM Ʈ  Ľϱ ؼ HTMLTagTraceHolder() ޼ҵ带
        //*           ȣմϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ DocumentComplete ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_DocumentComplete(object sender, AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEvent e)
        {
            string strTitle = "";

            SHDocVw.WebBrowser pDispWebBrowser = e.pDisp as SHDocVw.WebBrowser;
            if (pDispWebBrowser != null)
            {
                mshtml.IHTMLDocument2 objDocument2 = (IHTMLDocument2) pDispWebBrowser.Document;
                
                //** ̺Ʈ  
                this.navigationLogWrite(MessageType.Event, "ͳ ͽ÷η DocumentComplete ̺Ʈ ߻Ǿϴ.", objDocument2.url);

                //**   
                strTitle = objDocument2.title.Trim();
                if (strTitle == "") strTitle = " ";
                this.navigationLogWrite(MessageType.Information, strTitle + "  ε ϷǾϴ.", objDocument2.url);

                //** Ű  
                if (objDocument2.cookie != null)
                {
                    if (objDocument2.cookie.Trim() != strCookie) 
                    {
                        strCookie = objDocument2.cookie;
                        this.navigationLogWrite(MessageType.Cookie, objDocument2.cookie, objDocument2.url);
                    }
                }
                
                
                //***********************************************************************
                //* Ӽ  ʴ  -   Ѵ.
                //* Ӽ ϴ       -  ۾ Ϸ  ֻ 
                //*                                 Ӽ   Ѵ.
                //***********************************************************************

                if (objDocument2 == this.wbMain.Document)
                { 
                    //** α׷ ޼ 
                    this.navigationLogWrite(MessageType.Message, "ֻ  Ǵ Ӽ ̵ ϷǾϴ.", objDocument2.url);

                    //** tvHTMLDOM Ʈѿ Ʈ 带 ϱ ؼ Լ ȣϰ
                    //**  ϴ  ش  cmbFrame  
                    this.Cursor = Cursors.WaitCursor;

                    this.tvHTMLDOM.BeginUpdate();
                    this.cmbFrame.BeginUpdate();
                    this.tvHTMLDOM.Nodes.Clear();
                    this.cmbFrame.Items.Clear();
                    
                    int iFrameCnt = objDocument2.frames.length;
                    if (iFrameCnt > 0)
                    {
                        this.cmbFrame.Items.Add("ֻ Ӽ");
                        this.cmbFrame.Enabled = true;
                    }
                    else
                    {
                        this.cmbFrame.Items.Add("Ӽ  ʽϴ.");
                        this.cmbFrame.Enabled = false;
                    }

                    //**  HTML  DOM Ʈ  Ľϱ  HTMLTagTraceHolder() ޼ҵ ȣ
                    this.HTMLTagTraceHolder(objDocument2);

                    this.cmbFrame.SelectedIndex = 0;
                    this.cmbFrame.EndUpdate();
                    this.tvHTMLDOM.EndUpdate();

                    this.cmbAddress.Text = objDocument2.url;
                    this.Cursor = Cursors.Default;
                }
            }
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.25
        //* 
        //*   : 2004.03.24
        //* 
        //*     : e.command Ƽ e.enable Ƽ    Back 
        //*           ư Forward ư  ΰ ˴ϴ.
        //*
        //*           typedef enum CommandStateChangeConstants 
        //*           {
        //*               CSC_UPDATECOMMANDS = 0xFFFFFFFF,
        //*               CSC_NAVIGATEFORWARD = 0x00000001,
        //*               CSC_NAVIGATEBACK = 0x00000002
        //*           } CommandStateChangeConstants
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ CommandStateChange ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_CommandStateChange(object sender, AxSHDocVw.DWebBrowserEvents2_CommandStateChangeEvent e)
        {
            if (e.command == Convert.ToInt32(SHDocVw.CommandStateChangeConstants.CSC_NAVIGATEFORWARD))
            {
                this.tbMain.Buttons[1].Enabled = e.enable;
                this.menuForward.Enabled = e.enable;
            }
            else if (e.command == Convert.ToInt32(SHDocVw.CommandStateChangeConstants.CSC_NAVIGATEBACK))
            {
                this.tbMain.Buttons[0].Enabled = e.enable;
                this.menuBack.Enabled = e.enable;
            }
            else if (e.command == Convert.ToInt32(SHDocVw.CommandStateChangeConstants.CSC_UPDATECOMMANDS))
            {
                Int32 iOLECMDF = Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_SUPPORTED) + Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_ENABLED);
        
                this.tbRefresh.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_REFRESH)) == iOLECMDF);
                this.tbStop.Enabled = this.wbMain.Busy;
            }
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.25
        //* 
        //*   : 2004.02.25
        //* 
        //*     : e.text Ƽ  sbMain ¹ Ʈѿ ݿմϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ wbMain_StatusTextChange ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_StatusTextChange(object sender, AxSHDocVw.DWebBrowserEvents2_StatusTextChangeEvent e)
        {
            this.sbMain.Panels[0].Text = e.text;
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.24
        //* 
        //*   : 2004.03.24
        //* 
        //*     : e.text Ƽ  frmMain  ŸƲٿ ݿմϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ wbMain_TitleChange ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void wbMain_TitleChange(object sender, AxSHDocVw.DWebBrowserEvents2_TitleChangeEvent e)
        {
            this.Text = e.text + " - EgoCube IE Analysis 0.0.2";
        }

        #endregion

        #region DWebBrowserEvents Interface Implementation Code

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.02.20
        //* 
        //*   : 2004.03.19
        //* 
        //*     : Microsoft  ڷ - 325079  Ͻñ ٶϴ.
        //*           - 325079 - BUG: The BeforeNavigate2 Event of WebBrowser Control Does Not Fire If Hosted in a Visual C# .NET Application
        //*           - http://support.microsoft.com/default.aspx?scid=kb;en-us;325079
        //*            ̺Ʈ ֻ HTML  ̵ ۵Ǳ  ߻մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ BeforeNavigate2 ̺Ʈ 鷯 üϱ  ̺Ʈ 鷯Դϴ.
        /// </summary>
        public void BeforeNavigate(string URL, int Flags, string TargetFrameName, ref object PostData, string Headers, ref bool Cancel)
        {
            //** tmrSelector Ÿ̸ Ʈ 
            this.tmrSelector.Stop();
            iLastTagSrcIndex = -1;

            //** ׺̼ ̺Ʈ α 
            this.SetToolBarButtonState(ToolBarButtonState.EventList);

            //** α׷ ޼, ̺Ʈ     
            this.navigationLogWrite(MessageType.Message, "ֻ  Ǵ Ӽ ̵ մϴ.", URL);
            this.navigationLogWrite(MessageType.Event,   "ͳ ͽ÷η BeforeNavigate2 ̺Ʈ ߻Ǿϴ.", URL);
            if (Headers.Trim().Length != 0)
            {
                string [] aryHeaders = Headers.Split('\n');
                for (int i = 0; i < aryHeaders.Length; i++)
                {
                    aryHeaders[i] = aryHeaders[i].Trim().Replace("\r", "");
                    if (aryHeaders[i].Length != 0)
                        this.navigationLogWrite(MessageType.Header, aryHeaders[i], URL);
                }
            }

            //** cmbFrame ޺ڽ Ʈ Ӽ  
            this.cmbFrame.BeginUpdate();
            this.cmbFrame.Items.Clear();
            this.cmbFrame.Items.Add("Ӽ  мԴϴ.");
            this.cmbFrame.SelectedIndex = 0;
            this.cmbFrame.Enabled = false;
            this.cmbFrame.EndUpdate();

            //** tvHTMLDOM Ʈ Ʈ  DOM Ʈ  ʱȭ
            this.tvHTMLDOM.Nodes.Clear();
        }

        //*******************************************************************************
        //* 
        //*     : ̺Ʈ 鷯
        //* 
        //* ۼ  : ۿ
        //* 
        //* ۼ  : 2004.03.09
        //* 
        //*   : 2004.03.09
        //* 
        //*     :  ˾â  lvInfo Ʈ Ʈѿ մϴ.
        //*           
        //*******************************************************************************

        /// <summary>
        /// wbMain  Ʈ NewWindow ̺Ʈ 鷯Դϴ.
        /// </summary>
        public void NewWindow(string URL, int Flags, string TargetFrameName, ref object PostData, string Headers, ref bool Processed) 
        {
            this.navigationLogWrite(MessageType.Window, "ο ˾â µǾϴ.", URL);
        }

        public void PropertyChange(string Property) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void NavigateComplete(string URL) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void WindowActivate() 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void FrameBeforeNavigate(string URL, int Flags, string TargetFrameName, ref object PostData, string Headers, ref bool Cancel) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void FrameNewWindow(string URL, int Flags, string TargetFrameName, ref object PostData, string Headers, ref bool Processed) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void TitleChange(string Text) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void DownloadBegin() 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void DownloadComplete() 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void WindowMove() 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void WindowResize() 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void Quit(ref bool Cancel) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void ProgressChange(int Progress, int ProgressMax) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void StatusTextChange(string Text) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void CommandStateChange(int Command, bool Enable) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        public void FrameNavigateComplete(string URL) 
        {
            //**  ̺Ʈ 鷯  ʽÿ.
        }

        #endregion

        #region Menu Implementation Code

        /// <summary>
        /// '' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuFile_Click(object sender, System.EventArgs e)
        {
            Int32 iOLECMDF = Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_SUPPORTED) + Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_ENABLED);
            
            this.menuSave.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_SAVE)) == iOLECMDF);
            this.menuSaveAs.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_SAVEAS)) == iOLECMDF);
            this.menuPageSetup.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_PAGESETUP)) == iOLECMDF);
            this.menuPrint.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_PRINT)) == iOLECMDF);
            this.menuPrintPreview.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_PRINTPREVIEW)) == iOLECMDF);
            this.menuProperty.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_PROPERTIES)) == iOLECMDF);
        }

        /// <summary>
        /// ' - ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuSave_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_SAVE, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - ٸ ̸ ...' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuSaveAs_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_SAVEAS, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' -  ...' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuPageSetup_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_PAGESETUP, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - μ...' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuPrint_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_PRINT, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - μ ̸...' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuPrintPreview_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_PRINTPREVIEW, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - Ӽ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuProperty_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_PROPERTIES, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - ׺̼ ̺Ʈ α  ...' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuOpenNavigationEventLog_Click(object sender, System.EventArgs e)
        {
            this.OpenTextLog();
        }

        /// <summary>
        /// ' - ݱ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuExit_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// '' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuEdit_Popup(object sender, System.EventArgs e)
        {
            Int32 iOLECMDF = Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_SUPPORTED) + Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_ENABLED);
                
            this.menuCut.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_CUT)) == iOLECMDF);
            this.menuCopy.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_COPY)) == iOLECMDF);
            this.menuPaste.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_PASTE)) == iOLECMDF);
            this.menuSelectAll.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_SELECTALL)) == iOLECMDF);
        }

        /// <summary>
        /// ' - ߶󳻱' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuCut_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_CUT, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuCopy_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_COPY, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' - ٿֱ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuPaste_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_PASTE, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// ' -  ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuSelectAll_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_SELECTALL, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DODEFAULT, ref oEmpty, ref oEmpty);
        }

        /// <summary>
        /// '' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuView_Click(object sender, System.EventArgs e)
        {
            Int32 iOLECMDF = Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_SUPPORTED) + Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_ENABLED);

            this.menuStop.Enabled = this.wbMain.Busy;
            this.menuRefresh.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_REFRESH)) == iOLECMDF);
            this.menuTextSize.Enabled = (Convert.ToInt32(this.wbMain.QueryStatusWB(SHDocVw.OLECMDID.OLECMDID_ZOOM)) == Convert.ToInt32(SHDocVw.OLECMDF.OLECMDF_SUPPORTED));
        }
        
        /// <summary>
        /// ' - ̵ - ڷ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuBack_Click(object sender, System.EventArgs e)
        {
            this.wbMain.GoBack();
        }

        /// <summary>
        /// ' - ̵ - ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuForward_Click(object sender, System.EventArgs e)
        {
            this.wbMain.GoForward();
        }

        /// <summary>
        /// ' - ̵ - Ȩ ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuHome_Click(object sender, System.EventArgs e)
        {
            this.wbMain.GoHome();
        }

        /// <summary>
        /// ' - ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuStop_Click(object sender, System.EventArgs e)
        {
            this.wbMain.Stop();
        }

        /// <summary>
        /// ' - ΰħ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuRefresh_Click(object sender, System.EventArgs e)
        {
            object objRefreshConstants = 3;
            this.wbMain.Refresh2(ref objRefreshConstants);
        }

        /// <summary>
        /// ' - HTML ±' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuHTMLTag_Click(object sender, System.EventArgs e)
        {
            this.SetToolBarButtonState(ToolBarButtonState.HTML);
        }

        /// <summary>
        /// ' - ׺̼ ̺Ʈ α' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuNavigationEventLog_Click(object sender, System.EventArgs e)
        {
            this.SetToolBarButtonState(ToolBarButtonState.EventList);
        }

        /// <summary>
        /// ' - ؽƮ ũ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuTextSize_Popup(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            object oSize  = Type.Missing;

            foreach (MenuItem objItem in this.menuTextSize.MenuItems)
            {
                objItem.Checked = false;
            }
      
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_ZOOM, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref oEmpty, ref oSize);

            switch ((int) oSize)
            {
                case 4:

                    this.menuTextSize.MenuItems[0].Checked = true;
                    break;

                case 3:

                    this.menuTextSize.MenuItems[1].Checked = true;
                    break;

                case 2:

                    this.menuTextSize.MenuItems[2].Checked = true;
                    break;

                case 1:

                    this.menuTextSize.MenuItems[3].Checked = true;
                    break;

                case 0:

                    this.menuTextSize.MenuItems[4].Checked = true;
                    break;
            }
        }

        /// <summary>
        /// ' - ؽƮ ũ -  ũ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuTextSizeG_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            object oSize = (object) 4;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_ZOOM, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref oSize, ref oEmpty);
        }

        /// <summary>
        /// ' - ؽƮ ũ - ũ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuTextSizeL_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            object oSize = (object) 3;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_ZOOM, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref oSize, ref oEmpty);
        }

        /// <summary>
        /// ' - ؽƮ ũ - ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuTextSizeM_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            object oSize = (object) 2;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_ZOOM, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref oSize, ref oEmpty);
        }

        /// <summary>
        /// ' - ؽƮ ũ - ۰' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuTextSizeS_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            object oSize = (object) 1;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_ZOOM, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref oSize, ref oEmpty);
        }

        /// <summary>
        /// ' - ؽƮ ũ -  ۰' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuTextSizeA_Click(object sender, System.EventArgs e)
        {
            object oEmpty = Type.Missing;
            object oSize = (object) 0;
            this.wbMain.ExecWB(SHDocVw.OLECMDID.OLECMDID_ZOOM, SHDocVw.OLECMDEXECOPT.OLECMDEXECOPT_DONTPROMPTUSER, ref oSize, ref oEmpty);
        }

        /// <summary>
        /// ' - DOM Ʈ Ȯ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuDOMTreeExpand_Click(object sender, System.EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            this.tvHTMLDOM.ExpandAll();
            this.tvHTMLDOM.Nodes[0].EnsureVisible();
            this.Cursor = Cursors.Default;
        }

        /// <summary>
        /// ' - ͳ ͽ÷η ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuIEShow_Click(object sender, System.EventArgs e)
        {
            this.OpenInternetExplorer();
        }

        /// <summary>
        /// ' -  Ȩ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuHomepage_Click(object sender, System.EventArgs e)
        {
            this.OpenEgoCube("HOME");
        }

        /// <summary>
        /// ' - α׷ ٿε   ڷ' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuDownload_Click(object sender, System.EventArgs e)
        {
            this.OpenEgoCube("DOWNLOAD");
        }
        
        /// <summary>
        /// ' - EgoCube IE Analysis ...' ޴ ϸ ߻Ǵ ̺Ʈ 鷯Դϴ.
        /// </summary>
        private void menuAbout_Click(object sender, System.EventArgs e)
        {
            Form objAbout = new frmAbout();
            objAbout.ShowDialog(this);
        }

        #endregion
        
    }
}